---
template: documentation
title: Documentation index
subtitle: Learn how to use PHP-DI.
tab: index
---

## Introduction

* [Understanding dependency injection](understanding-di.md)
* [Getting started](getting-started.md)
* [Best practices guide](best-practices.md)

## PHP-DI's documentation

* [Configure the container](container-configuration.md)
* [Use the container](container.md)
* [Define injections](definition.md)
* [Definition overriding](definition-overriding.md)
* [Lazy injection](lazy-injection.md)
* [Scopes](scopes.md)

### Frameworks integration

- [Symfony 2](frameworks/symfony2.md)
- [Zend Framework 1](frameworks/zf1.md)
- [Zend Framework 2](https://github.com/mnapoli/PHP-DI-ZF2) (beta version)

### Extra topics

* [Performances](performances.md)
* [Inject on an existing instance](inject-on-instance.md)
* [Injections depending on the environment](environments.md)

### Migration guides

* [Migration from PHP-DI 3.x to 4.0](migration/4.0.md)

## Internals

* [Contribute](../CONTRIBUTING.md)
* [How PHP-DI works](how-it-works.md)

PHP-DI is under the MIT license.

This documentation is also embedded in [PHP-DI's git repository](https://github.com/mnapoli/PHP-DI/tree/4.0/doc)
so you can read it offline (in the `doc/` folder).
